%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% this function colormean tries to find the color mean of the data set
% for each color in the image, record its weights: how many points in the image with this color
% Must consider the weights while computing the mean 
% programmer: Qifang Xu
% cis581 project
% date: November 4, 2002

% input: a matrix of each color with weights
% output: return mean

function [stdv] = find_std(data, mn)
[row, col] = size(data);
sumR = 0;
sumG = 0;
sumB = 0;
count = 0;
for i = 1:row
    sumR = sumR + data(i, col) * (data(i, 1) - mn(1))^2;
    sumG = sumG + data(i, col) * (data(i, 2) - mn(2))^2;
    sumB = sumB + data(i, col) * (data(i, 3) - mn(3))^2;
    count = count + data(i, col);
end

stdv(1) = sqrt(sumR) / (count - 1);
stdv(2) = sqrt(sumG) / (count - 1);
stdv(3) = sqrt(sumB) / (count - 1);


return;