% normalize.m , 03/20/98

% if meanvv, stdvv are empty, normalizes data by columns
% and returns mean and std values
% else uses meanvv, stdvv to rescale data

function [meanv,stdv,datanew]=normalize(data,meanvv,stdvv)

a=size(data);
e=ones(a(1),1);
if length(meanvv)==0
   meanv=findMean(data);
   stdv=findStd(data, meanv);
   q=find(stdv<0.01);
   stdv(q)=1000;
else
   meanv=meanvv;
   stdv=stdvv;
end

for i=1:a(2)
   x=data(:,1:3)-e*meanv;
   datanew(:,1)=x(:, 1)/stdv(1);
   datanew(:,2)=x(:, 2)/stdv(2);
   datanew(:,3)=x(:, 3)/stdv(3);
end

return;