function [cluster, no, centroid]= recurauto1(x,dist,scale,mainindex,cluster, no, centroid, value, mnp, percentage)

%figure('name','histogram of distances'); hist(dist,scale) %Histogram of distances

d(:, 1) = dist(:, 1);
d(:, 2) = x(:, 4);

[n, xnum] = myhist(d, scale);  %This returns the bins and number of occurences
sumn = sum(n);
flag = 0;
k = 1;

for i = 1:size(n,2)-1     %Matrix A formed to find the threshold of cutting point
   if n(i) == 0 & flag == 0
       continue
   end
    A(k,1) = xnum(i);
    A(k,2) = n(i);
    A(k,3) = xnum(i+1);
    A(k,4) = n(i+1);
    k = k+1;
    flag = 1;
end
A(k,1) = A(k-1,3);
A(k,2) = A(k-1,4);
b = evo2(A); % Returns a threshold where split can be made (discrete curve evolution)

[lmainindex,rmainindex,ldata,ldist,rdata,rdist,cluster,no,centroid] = split2(x,dist,b,mainindex,scale,mnp,percentage,cluster,no,centroid); %Split function called to split the data around the threshold
    
if lmainindex ~= 0
    xleftmean = findDistMean(ldist, ldata(:, 4));    %Average of the left distances
    [index] = ptclosest(ldist,xleftmean); %Index of the point closest to the average distance
    
    for i=1:size(ldata,1)
        ptclosest_dist_left(i, 1)=  dist2pt(ldata(i,:), ldata(index,:));  %Finding the distances of all the points closest from
    end                                                              %the mean
    
    [cluster,no,centroid] = recurauto1(ldata,ptclosest_dist_left,scale,lmainindex,cluster,no,centroid,index,mnp,percentage); %calling recursive function again
end

if rmainindex ~= 0
    xrightmean = findDistMean(rdist, rdata(:, 4));       %Same procedure followed for the right values
    [index] = ptclosest(rdist,xrightmean);
    
    for i=1:size(rdata,1)
        ptclosest_dist_right(i, 1) = dist2pt(rdata(i,:), rdata(index,:));
    end
    
    [cluster, no, centroid] = recurauto1(rdata,ptclosest_dist_right,scale,rmainindex,cluster,no,centroid,index,mnp,percentage);
end

return